import os
import stat
import sys
from pathlib import Path
from file_functions import *
import json
import io
import re

plugin_folder = r"\Engine\Plugins"
buildID_location = r"\Engine\Binaries\Win64\UE4Editor.modules"
buildIDRegex = "\"BuildId\": \"(.*)\","

build_id = "\"BuildId\": \"XXX\","
replacedCount = 0

def replaceBuildID(input):
    input = input.decode()
    output = re.sub(buildIDRegex, build_id, input)
    return output.encode()


def find_folder(dir, extension):
    if (os.path.exists(dir + extension)):
        return dir + extension
    else:
        return find_folder(os.path.dirname(dir), extension)


def potentially_replace_buildid(file):
    if (file.endswith("UE4Editor.modules")):
        os.chmod(file, stat.S_IWRITE)
        replace_file_content(file, replaceBuildID)
        print ("replacing:" + file)
        global replacedCount
        replacedCount += 1

def main():
    global build_id
    print (os.getcwd())

    build_id = re.search(buildIDRegex, getFileContents(find_folder(os.getcwd(), buildID_location))).group(0)
    print ("Determined build id: " + build_id)
    execute_for_all_files(find_folder(os.getcwd(), plugin_folder),potentially_replace_buildid)
    print ("Done, set up buildID for " + str(replacedCount) + " plugins") 

if __name__ == "__main__":
    main()
